package P6C::Context;
use strict;
use Class::Struct P6C::Context => { qw(type $) };

=pod

type is a ref to one of the following:

* a typename (e.g. PerlString or PerlArray)

* an array of contexts representing a tuple.

=cut

my %isscalar;

use constant MANY => 10_000_000;

BEGIN {
    my @scalar_types = qw(PerlInt PerlNum PerlString PerlUndef);
    $isscalar{@scalar_types} = (1) x @scalar_types;
}

sub nelem {
    my $ctx = shift->type;
    if (!ref($ctx)) {
	return $isscalar{$ctx} ? 1 : MANY;
    }
    return @$ctx;
}

sub is_scalar {
    my $ctx = shift->type;
    print STDERR "isscalar: $ctx\n";
    if (!ref($ctx)) {
	return 1 unless $ctx eq 'PerlArray' || $ctx eq 'PerlHash';
	# XXX: probably some sort of initialization issues going on here.
#	return exists $isscalar{$ctx};
    }
    return 0;
}

sub is_tuple {
    my $type = shift->type;
    return ref($type) eq 'ARRAY';
}

sub is_array {
    my $type = shift->type;
    return $type eq 'PerlArray';
}

sub same {
    return 1;			# XXX: not correct...
}

1;
