use Class::Struct P6C::Binop => { qw(op $ l $ r $) };
use Class::Struct P6C::sv_literal => { qw(type $ lval $) };
use Class::Struct P6C::av_literal => { qw(type $ lval $) };
use Class::Struct P6C::hv_literal => { qw(type $ lval $) };
use Class::Struct P6C::variable => { qw(type     $
					global   $
					implicit $
					topical  $
					name     $) };
use Class::Struct P6C::hype => { qw(op $) };
use Class::Struct P6C::indices => { qw(type $ indices $) };
use Class::Struct P6C::context => { qw(ctx $ thing $) };
# XXX: doesn't appear in the parse tree:
use Class::Struct P6C::subscript_exp => { qw(thing $ subscripts @) };

use Class::Struct P6C::incr => { qw(post $ op $ thing $) };
use Class::Struct P6C::prefix => { qw(name $ args $) };

use Class::Struct P6C::pair => { qw(l $ r $) };

use Class::Struct P6C::range => { qw(l $ r $) };

use Class::Struct P6C::compare => { qw(seq @) };
# NOTE: compare is different because they can be chained.

use Class::Struct P6C::ternary => { qw(if $ then $ else $) };

use Class::Struct P6C::scope_class => { qw(scope $ class $) };

use Class::Struct P6C::decl => { qw(qual $ vars @ props @) };
use Class::Struct P6C::property => { qw(name $ args $) };

use Class::Struct P6C::but => { qw(buts @ thing $) };
use Class::Struct P6C::adverb => { qw(adv $ thing $) };
use Class::Struct P6C::params => { qw(req @ opt @ rest $) };
use Class::Struct P6C::param => { qw(qual $ var $ props @ init $) };
use Class::Struct P6C::initializer => { qw(op $ expr $) };

# NOTE: these types don't appear in the grammar only because they've
# been inlined away.  Inlining them away here would just be painful.

use Class::Struct P6C::sub_def => { qw(qual $ name $ props @ closure $) };
use Class::Struct P6C::class_def => { qw(qual $ name $ props @ block $) };
use Class::Struct P6C::guard => { qw(name $ test $ expr $) };
use Class::Struct P6C::directive => { qw(name $ thing $ args $) };
use Class::Struct P6C::loop => { qw(init $ test $ incr $ block $) };
use Class::Struct P6C::label => { qw(name $) };

use Class::Struct P6C::yadda => { qw(msg $) }; # i.e. "..."
use Class::Struct P6C::closure => { qw(params $ block $) };
use Class::Struct P6C::apply_rhs => { qw(prop $ subscripts @) };

sub P6C::params::min {
    my $x = shift;
    scalar @{$x->req()}
}

sub P6C::params::max {
    my $x = shift;
    if ($x->rest) {
	return undef;
    }
    return @{$x->req()} + @{$x->opt()};
}

sub P6C::compare::size {
    (@{shift->seq()} - 1) / 2
}

"Yep.";
