######################################################################
# General utilities
package P6C::Util;
require Exporter;
our @EXPORT = qw(unimp diag flatten_leftop);
our @ISA = qw(Exporter);

sub _info {
    my ($pack, $fn, $line, $subr) = caller 2;
    $subr =~ s/^P6C:://;
    warn "[$subr (not implemented)] ", @_, "\n";
}

sub unimp {
    _info @_;
    die;
}

sub diag {
    _info @_;
}

# @l = flatten_leftop($l, $op)
#
#	flatten $l, a binary operator tree, into a sequence of items
#	that were once the right- and left-hand operands of that
#	operator.  Only works if the indicated operator is the
#	lowest-precedence operator in the tree.  So (1,(2,(3,4)))
#	becomes (1 2 3 4).  Yes, this is undoing what we so
#	laboriously did in Tree.pm turning <leftop:...> sequences into
#	trees.
#
sub flatten_leftop {
    my ($x, $op) = @_;
    my @ret;
    while (1) {
	if ($x->isa('P6C::Binop') && $x->op eq $op) {
	    unshift @ret, $x->r;
	    $x = $x->l;
	} else {
	    unshift @ret, $x;
	    last;
	}
    }
    return @ret;
}

1;
